/** 
* Copyright (c) 2007 Guido Angenendt <guido.angenendt@stud.uni-due.de>
*
*    This file is part of hellaKommanda.
*
*    hellaKommanda is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    hellaKommanda is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with hellaKommanda.  If not, see <http://www.gnu.org/licenses/>.
**/

//
// Global variables
//
var serverUrl;
var secXmlRpcClient;


//
// Functions
//

// Open preferences window
function open_pref() {
	window.open('chrome://hellakommanda/content/pref.xul',
	'pref','chrome, centerscreen');
}

// Open about window
function open_about() {
	window.open('chrome://hellakommanda/content/about.xul',
	'about','chrome, width=300, height=350, centerscreen');
}

// Create instace of xmlrpc client
function getClient() {

	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	
	// Return instance	
	return Components.classes['@mozilla.org/xml-rpc/client;1'].createInstance(
		Components.interfaces.nsIXmlRpcClient);
}

// Get instance of (secondary) xmlrpc client
function getXmlRpc() {
	if (!secXmlRpcClient) {
		secXmlRpcClient = getClient();
		}
		
	if (!serverUrl) {
		serverUrl = getUrl();
		}
		
	secXmlRpcClient.init(serverUrl);

	return secXmlRpcClient;
}

// Get server url from settings file
function getUrl() {

	var xmlDoc = document.implementation.createDocument("","",null);
	xmlDoc.async = false;
	try { xmlDoc.load("chrome://hellakommanda/content/settings.xml");}
	catch (e) {}
	
	var server = xmlDoc.getElementsByTagName("server").item(0).firstChild.nodeValue;
	var port = xmlDoc.getElementsByTagName("port").item(0).firstChild.nodeValue;
	var password = xmlDoc.getElementsByTagName("password").item(0).firstChild.nodeValue;
	
	//http://hellanzb:<passwd>@<host>:<port>
	return "http://hellanzb:" + password + "@" + server + ":" + port;
}

// Get ID of currently selected nzb in queue tree
function getId() {
	var id;
	var tree = document.getElementById('tree2');
	var index =	tree.currentIndex;
	var col = tree.columns.getNamedColumn('id');
	if (index != -1) {
		var treeview = tree.view.QueryInterface(Components.interfaces.nsITreeView);
		id = treeview.getCellText(index, col);
		return id;
	} else {
		return id;
	}
}

// Get value of postid textbox
function getPostId() {
	var postid = document.getElementById('postid').value;

	return postid;
}

function rebuildQueue() {
	var tree = document.getElementById('tree2');
	tree.builder.rebuild();
}	

//
// XMLRPC CALLS
//
// Toggle pause/conitnue
function togglePauseContinue() {

	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	var button = document.getElementById('tpc');
	// Send call
	xmlRpcClient.asyncCall(toggleHandler, button, 'status', [], 0);
	rebuildQueue();
}

// Send call to pause daemon
function send_pause() {
	
	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Send call
	xmlRpcClient.asyncCall(null, null, 'pause', [], 0);
}

// Send call to continue daemon
function send_continue() {

	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Send call
	xmlRpcClient.asyncCall(null, null, 'continue', [], 0);
}

// Send call to cancel daemon
function send_cancel() {

	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Send call
	xmlRpcClient.asyncCall(null, null, 'cancel', [], 0);
	rebuildQueue();
}

// Send call to dequeue selected nzb
function send_dequeue() {

	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Create an empty XML-RPC string value object to use as a parameter
	var id = xmlRpcClient.createType(xmlRpcClient.INT,{});
	// Store in in a value from the XUL form
	id.data = getId();
	// Send call
	xmlRpcClient.asyncCall(null, null, 'dequeue', [id], 1);
	rebuildQueue();

}

// Send call to enqueue nzb with msgid specified
function send_enqueue() {

	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Create an empty XML-RPC string value object to use as a parameter
	var postid = xmlRpcClient.createType(xmlRpcClient.INT,{});
	// Store in in a value from the XUL form
	postid.data = getPostId();
	// Send call
	xmlRpcClient.asyncCall(null, null, 'enqueuenewzbin', [postid], 1);
	rebuildQueue();
}

// Send call to force download of selected nzb
function send_force() {

	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Create an empty XML-RPC string value object to use as a parameter
	var id = xmlRpcClient.createType(xmlRpcClient.INT,{});
	// Store in in a value from the XUL form
	id.data = getId();
	xmlRpcClient.asyncCall(null, null, 'force', [id], 1);
	rebuildQueue();

}

// Send call to move selected nzb up in the queue
function send_up() {
	
	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Create an empty XML-RPC string value object to use as a parameter
	var id = xmlRpcClient.createType(xmlRpcClient.INT,{});
	// Store in in a value from the XUL form
	id.data = getId();
	// Send call
	xmlRpcClient.asyncCall(null, null, 'up', [id], 1);
	rebuildQueue();
}

// Send call to move selected nzb down in the queue
function send_down() {
	
	// Grant rights
	netscape.security.PrivilegeManager.enablePrivilege(
		'UniversalXPConnect UniversalBrowserAccess');
	// Get the instance of the XML-RPC client
	var xmlRpcClient = getXmlRpc();
	// Create an empty XML-RPC string value object to use as a parameter
	var id = xmlRpcClient.createType(xmlRpcClient.INT,{});
	id.data = getId();
	// Send call
	xmlRpcClient.asyncCall(null, null, 'down', [id], 1);
	rebuildQueue();
}

//
// Handlers
//
// Handle toggling of pause/continue
var toggleHandler = {

	onResult: function(client, button, result) {
		
		// Grant rights
		netscape.security.PrivilegeManager.enablePrivilege(
			'UniversalXPConnect UniversalBrowserAccess');
			
		// Prepare data
		var statusResult = result.QueryInterface(Components.interfaces.nsIDictionary);
		var value = statusResult.getValue('is_paused')
						.QueryInterface(Components.interfaces.nsISupportsPRBool);
		
		// Send call and change icon accordingly	
		if (value == 'true') {
			send_continue();
			button.setAttribute('image', 'img/pause.png');
		} else { 
				send_pause();
				button.setAttribute('image', 'img/continue.png');
		}
	},
		
	onFault: function (client, ctxt, fault) {
		alert('XML-RPC Fault: '+fault);
	},

	onError: function (client, ctxt, status, errorMsg) {
		alert('Error: '+errorMsg);
	}
};
